carta
gss_sign(3)

gss_sign3

Generic security service application program interface library

Usage

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

OM_uint32

Library

GSS-API library (libgssapi, -lgssapi)

Overview

Generic Security Service API (GSS-API) version 2, and its C binding, is described in RFC2743 and RFC2744. Version 1 (deprecated) of the C binding is described in RFC1509.

Heimdals GSS-API implementation supports the following mechanisms

  • GSS_KRB5_MECHANISM

  • GSS_SPNEGO_MECHANISM

GSS-API have generic name types that all mechanism are supposed to implement (if possible):

  • GSS_C_NT_USER_NAME

  • GSS_C_NT_MACHINE_UID_NAME

  • GSS_C_NT_STRING_UID_NAME

  • GSS_C_NT_HOSTBASED_SERVICE

  • GSS_C_NT_ANONYMOUS

  • GSS_C_NT_EXPORT_NAME

GSS-API implementations that supports Kerberos 5 have some additional name types:

  • GSS_KRB5_NT_PRINCIPAL_NAME

  • GSS_KRB5_NT_USER_NAME

  • GSS_KRB5_NT_MACHINE_UID_NAME

  • GSS_KRB5_NT_STRING_UID_NAME

In GSS-API, names have two forms, internal names and contiguous string names.

  • Internal name and mechanism name

    Internal names are implementation specific representation of a GSS-API name. Mechanism names special form of internal names corresponds to one and only one mechanism.

    In GSS-API an internal name is stored in a gss_name_t.

  • Contiguous string name and exported name

    Contiguous string names are gssapi names stored in a OCTET STRING that together with a name type identifier (OID) uniquely specifies a gss-name. A special form of the contiguous string name is the exported name that have a OID embedded in the string to make it unique. Exported name have the nametype GSS_C_NT_EXPORT_NAME.

    In GSS-API an contiguous string name is stored in a gss_buffer_t.

    Exported names also have the property that they are specified by the mechanism itself and compatible between different GSS-API implementations.

Access control

There are two ways of comparing GSS-API names, either comparing two internal names with each other or two contiguous string names with either other.

To compare two internal names with each other, import (if needed) the names with gss_import_name() into the GSS-API implementation and the compare the imported name with gss_compare_name().

Importing names can be slow, so when its possible to store exported names in the access control list, comparing contiguous string name might be better.

when comparing contiguous string name, first export them into a GSS_C_NT_EXPORT_NAME name with gss_export_name() and then compare with memcmp(3).

Note that there are might be a difference between the two methods of comparing names. The first (using gss_compare_name()) will compare to (unauthenticated) names are the same. The second will compare if a mechanism will authenticate them as the same principal.

For example, if gss_import_name() name was used with GSS_C_NO_OID the default syntax is used for all mechanism the GSS-API implementation supports. When compare the imported name of GSS_C_NO_OID it may match several mechanism names (MN).

The resulting name from gss_display_name() must not be used for acccess control.

Functions

gss_display_name() takes the gss name in input_name and puts a printable form in output_name_buffer. output_name_buffer should be freed when done using gss_release_buffer(). output_name_type can either be NULL or a pointer to a gss_OID and will in the latter case contain the OID type of the name. The name must only be used for printing. If access control is needed, see section ACCESS CONTROL.

gss_inquire_context() returns information about the context. Information is available even after the context have expired. lifetime_rec argument is set to GSS_C_INDEFINITE (don't expire) or the number of seconds that the context is still valid. A value of 0 means that the context is expired. mech_type argument should be considered readonly and must not be released. src_name and dest_name() are both mechanims names and must be released with gss_release_name() when no longer used.

gss_context_time will return the amount of time (in seconds) of the context is still valid. If its expired time_rec will be set to 0 and GSS_S_CONTEXT_EXPIRED returned.

gss_sign(), gss_verify(), gss_seal(), and gss_unseal() are part of the GSS-API V1 interface and are obsolete. The functions should not be used for new applications. They are provided so that version 1 applications can link against the library.

Extensions

gss_krb5_ccache_name() sets the internal kerberos 5 credential cache name to name. The old name is returned in old_name, and must not be freed. The data allocated for old_name is free upon next call to gss_krb5_ccache_name(). This function is not threadsafe if old_name argument is used.

gss_krb5_copy_ccache() will extract the krb5 credentials that are transferred from the initiator to the acceptor when using token delegation in the Kerberos mechanism. The acceptor receives the delegated token in the last argument to gss_accept_sec_context().

gss_krb5_import_cred() will import the krb5 credentials (both keytab and/or credential cache) into gss credential so it can be used withing GSS-API. The ccache is copied by reference and thus shared, so if the credential is destroyed with krb5_cc_destroy, all users of thep gss_cred_id_t returned by gss_krb5_import_ccache() will fail.

gsskrb5_register_acceptor_identity() sets the Kerberos 5 filebased keytab that the acceptor will use. The identifier is the file name.

gsskrb5_extract_authz_data_from_sec_context() extracts the Kerberos authorizationdata that may be stored within the context. Tha caller must free the returned buffer ad_data with gss_release_buffer() upon success.

gss_krb5_get_tkt_flags() return the ticket flags for the kerberos ticket receive when authenticating the initiator. Only valid on the acceptor context.

gss_krb5_compat_des3_mic() turns on or off the compatibility with older version of Heimdal using des3 get and verify mic, this is way to programmatically set the [gssapi]broken_des3_mic and [gssapi]correct_des3_mic flags (see COMPATIBILITY section in gssapi(3)). If the CPP symbol GSS_C_KRB5_COMPAT_DES3_MIC is present, gss_krb5_compat_des3_mic() exists. gss_krb5_compat_des3_mic() will be removed in a later version of the GSS-API library.

History

  • Debian 13 (Trixie) to Debian 9 (Stretch): the text shown here
  • Debian 8 (Jessie)
  • Debian 7 (Wheezy)
  • Debian 6.0 (Squeeze)
  • Debian 5.0 (Lenny)
  • Debian 4.0 (Etch)
  • Debian 3.1 (Sarge)

From heimdal-dev 7.8.git20221117.28daf24+dfsg-9+deb13u1 in Debian 13 (Trixie). Parsed by carta from the page's mdoc source.